declare module "src/store-config.model" {
    export interface StoreConfig {
        InitialState: any;
        reducer: any;
        epics: any[];
    }
    export interface StoreConfigs {
        [key: string]: StoreConfig;
    }
}
declare module "src/epic-decorator" {
    import { Action } from 'redux';
    export interface EpicMetadata {
        propertyName: string;
    }
    export function Epic(): PropertyDecorator;
    export function getEpicsMetadata(instance: any): EpicMetadata[];
    export function createEpics<T extends Action, S, D = any>(epic: any, ...epicsOrOptions: any[]): any[];
}
declare module "src/store-config.service" {
    import { NgRedux } from "@angular-redux/store";
    import { StoreConfig, StoreConfigs } from "src/store-config.model";
    import { Action } from "redux";
    import { EpicMiddleware } from "redux-observable";
    export const storeConfigs: StoreConfigs;
    export const dynamicEpicMiddleware: EpicMiddleware<Action, {}, any>;
    export class StoreConfigService {
        private store;
        ActionTypes: {
            ModuleAdd: string;
        };
        constructor(store: NgRedux<any>);
        addModule(moduleName: string, initialState: any, reducer: any, epics?: any[]): void;
    }
    export function reigsterModules(): StoreConfig;
}
declare module "src/dispatcher" {
    import { Action } from "redux";
    import { NgRedux } from "@angular-redux/store/lib/src";
    export class Dispatcher<TAction extends Action> {
        private redux;
        constructor(redux: NgRedux<any>);
        dispatch(action: TAction): TAction;
    }
}
declare module "src/store-module" {
    import { NgRedux, DevToolsExtension } from "@angular-redux/store";
    export class StoreModule {
        constructor(store: NgRedux<any>, devTools: DevToolsExtension);
    }
}
declare module "src/actions-base" {
    import { Action } from "redux";
    export abstract class ActionsBase<TAction extends Action> {
        dispatch: (action: TAction) => TAction;
    }
}
declare module "index" {
    export { StoreModule } from "src/store-module";
    export { StoreConfigService } from "src/store-config.service";
    export { ActionsBase } from "src/actions-base";
    export { Epic } from "src/epic-decorator";
    export { Dispatcher } from "src/dispatcher";
}
