var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define("src/store-config.model", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
});
define("src/epic-decorator", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var METADATA_KEY = 'redux-observable-decorator-metadata';
    function Epic() {
        return function (target, propertyName) {
            if (!Reflect.hasOwnMetadata(METADATA_KEY, target)) {
                Reflect.defineMetadata(METADATA_KEY, [], target);
            }
            var epics = Reflect.getOwnMetadata(METADATA_KEY, target);
            var metadata = { propertyName: propertyName };
            Reflect.defineMetadata(METADATA_KEY, epics.concat([metadata]), target);
        };
    }
    exports.Epic = Epic;
    function getEpicsMetadata(instance) {
        var target = Object.getPrototypeOf(instance);
        if (!Reflect.hasOwnMetadata(METADATA_KEY, target)) {
            return [];
        }
        return Reflect.getOwnMetadata(METADATA_KEY, target);
    }
    exports.getEpicsMetadata = getEpicsMetadata;
    function isOptions() {
        var instanceOrOptions = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            instanceOrOptions[_i] = arguments[_i];
        }
        var option = instanceOrOptions[instanceOrOptions.length - 1];
        var keys = option ? Object.keys(option) : [];
        return keys.indexOf('dependencies') >= 0 || keys.indexOf('adapter') >= 0;
    }
    function createEpics(epic) {
        var epicsOrOptions = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            epicsOrOptions[_i - 1] = arguments[_i];
        }
        var instances;
        var options;
        if (isOptions.apply(void 0, epicsOrOptions)) {
            options = epicsOrOptions.slice(epicsOrOptions.length - 1, epicsOrOptions.length)[0];
        }
        instances = [epic].concat(epicsOrOptions);
        var epicsMetaData = instances
            .map(function (instance) { return getEpicsMetadata(instance)
            .map(function (_a) {
            var propertyName = _a.propertyName;
            return instance[propertyName];
        }); });
        var epics = [].concat.apply([], epicsMetaData);
        return epics;
        // const rootEpic = combineEpics(...epics);
        // return createEpicMiddleware(rootEpic, options);
    }
    exports.createEpics = createEpics;
});
define("src/store-config.service", ["require", "exports", "@angular/core", "@angular-redux/store", "redux", "src/epic-decorator", "@angular-redux/router", "redux-observable"], function (require, exports, core_1, store_1, redux_1, epic_decorator_1, router_1, redux_observable_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.storeConfigs = {};
    exports.dynamicEpicMiddleware = redux_observable_1.createEpicMiddleware(redux_observable_1.combineEpics.apply(void 0, []));
    var StoreConfigService = /** @class */ (function () {
        function StoreConfigService(store) {
            this.store = store;
            this.ActionTypes = {
                ModuleAdd: '[StoreConfig] Module Add'
            };
        }
        StoreConfigService.prototype.addModule = function (moduleName, initialState, reducer, epics) {
            exports.storeConfigs[moduleName] = {
                InitialState: initialState,
                reducer: reducer,
                epics: epics || []
            };
            var newConfig = reigsterModules();
            var newInitialState = newConfig.InitialState;
            var mergedState = __assign({}, this.store.getState(), { newInitialState: newInitialState });
            var newEpic = redux_observable_1.combineEpics.apply(void 0, newConfig.epics);
            exports.dynamicEpicMiddleware.replaceEpic(newEpic);
            this.store.replaceReducer(function (x) { return mergedState; }); // Trivial reducer that just returns the saved state.
            this.store.dispatch({ type: this.ActionTypes.ModuleAdd, payload: moduleName }); // Bogus action to trigger the reducer above.
            this.store.replaceReducer(newConfig.reducer);
        };
        StoreConfigService = __decorate([
            core_1.Injectable(),
            __metadata("design:paramtypes", [store_1.NgRedux])
        ], StoreConfigService);
        return StoreConfigService;
    }());
    exports.StoreConfigService = StoreConfigService;
    function reigsterModules() {
        var items = exports.storeConfigs;
        // Initial State
        var initialState = {};
        var reducerMap = {};
        var epicClasses = [];
        for (var key in items) {
            if (!items.hasOwnProperty(key)) {
                continue;
            }
            initialState[key] = items[key].InitialState;
            reducerMap[key] = items[key].reducer;
            epicClasses.push.apply(epicClasses, items[key].epics);
        }
        // Reducers
        var rootReducer = redux_1.combineReducers(__assign({ router: router_1.routerReducer }, reducerMap));
        // Epics
        var epicInstances = epicClasses;
        // 	.map(x => {
        // 	return injector.get(x);
        // });
        var epics = epicInstances.map(function (x) { return epic_decorator_1.createEpics(x); }).reduce(function (a, b) { return a.concat(b); }, []);
        return {
            InitialState: initialState,
            reducer: rootReducer,
            epics: epics
        };
    }
    exports.reigsterModules = reigsterModules;
});
define("src/dispatcher", ["require", "exports", "@angular/core", "@angular-redux/store/lib/src"], function (require, exports, core_2, src_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Dispatcher = /** @class */ (function () {
        function Dispatcher(redux) {
            this.redux = redux;
        }
        Dispatcher.prototype.dispatch = function (action) {
            return this.redux.dispatch(action);
        };
        Dispatcher = __decorate([
            core_2.Injectable(),
            __metadata("design:paramtypes", [src_1.NgRedux])
        ], Dispatcher);
        return Dispatcher;
    }());
    exports.Dispatcher = Dispatcher;
});
define("src/store-module", ["require", "exports", "@angular/core", "@angular-redux/store", "@angular-redux/router", "src/store-config.service", "src/dispatcher"], function (require, exports, core_3, store_2, router_2, store_config_service_1, dispatcher_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var StoreModule = /** @class */ (function () {
        function StoreModule(store, devTools) {
            var config = store_config_service_1.reigsterModules();
            store.configureStore(config.reducer, config.InitialState, [store_config_service_1.dynamicEpicMiddleware].concat(config.epics), devTools.isEnabled() ? [devTools.enhancer()] : []);
            if (window.devToolsExtension) {
                window.devToolsExtension.updateStore(store['_store']);
            }
        }
        StoreModule = __decorate([
            core_3.NgModule({
                imports: [store_2.NgReduxModule, router_2.NgReduxRouterModule],
                providers: [store_config_service_1.StoreConfigService, dispatcher_1.Dispatcher]
            }),
            __metadata("design:paramtypes", [store_2.NgRedux,
                store_2.DevToolsExtension])
        ], StoreModule);
        return StoreModule;
    }());
    exports.StoreModule = StoreModule;
});
define("src/actions-base", ["require", "exports", "@angular-redux/store"], function (require, exports, store_3) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ActionsBase = /** @class */ (function () {
        function ActionsBase() {
            this.dispatch = function (action) { return action; };
        }
        __decorate([
            store_3.dispatch(),
            __metadata("design:type", Object)
        ], ActionsBase.prototype, "dispatch", void 0);
        return ActionsBase;
    }());
    exports.ActionsBase = ActionsBase;
});
define("index", ["require", "exports", "src/store-module", "src/store-config.service", "src/actions-base", "src/epic-decorator", "src/dispatcher"], function (require, exports, store_module_1, store_config_service_2, actions_base_1, epic_decorator_2, dispatcher_2) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.StoreModule = store_module_1.StoreModule;
    exports.StoreConfigService = store_config_service_2.StoreConfigService;
    exports.ActionsBase = actions_base_1.ActionsBase;
    exports.Epic = epic_decorator_2.Epic;
    exports.Dispatcher = dispatcher_2.Dispatcher;
});
